> For the complete documentation index, see [llms.txt](https://docs.seismic.systems/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.seismic.systems/reference/precompiles/aes-gcm-decrypt.md).

# AES-GCM Decrypt

Decrypt data that was encrypted with [AES-256-GCM](https://en.wikipedia.org/wiki/Galois/Counter_Mode). Verifies the authentication tag before returning the plaintext. If the tag does not match (indicating tampering or wrong key), the call fails.

## Input

Raw bytes in the following layout:

| Offset    | Field                 | Type     | Description                             |
| --------- | --------------------- | -------- | --------------------------------------- |
| `[0:32]`  | key                   | 32 bytes | AES-256 key (must match encryption key) |
| `[32:44]` | nonce                 | 12 bytes | Initialization vector                   |
| `[44:]`   | ciphertext + auth tag | bytes    | Encrypted data with authentication tag  |

## Output

| Bytes     | Type  | Description    |
| --------- | ----- | -------------- |
| plaintext | bytes | Decrypted data |

## Use cases

* On-chain decryption of previously encrypted data
* Decrypting messages from other contracts or users
* Verifying and reading encrypted event data within a contract

## Examples

### Built-in helper

```solidity
function aes_gcm_decrypt(sbytes32 key, uint96 nonce, bytes memory ciphertext) view returns (bytes memory);
```

```solidity
bytes memory plaintext = aes_gcm_decrypt(aesKey, nonce, ciphertext);
```

### Manual usage

```solidity
function aesDecrypt(
    suint256 key,
    uint96 nonce,
    bytes memory ciphertext
) internal view returns (bytes memory) {
    bytes memory input = abi.encodePacked(uint256(key), nonce, ciphertext);
    (bool success, bytes memory result) = address(0x67).staticcall(input);
    require(success, "AES-GCM Decrypt precompile failed");
    return result;
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.seismic.systems/reference/precompiles/aes-gcm-decrypt.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
